EDIT - task #3348

should annotations always be returned for cdm instances? [DISCUSS]
03/13/2013 01:40 PM - Andreas Kohlbecker

Status: In Progress Start date:

Priority: Priority14 Due date:

Assignee: Andreas Muller % Done: 20%
Category: cdmlib-remote Estimated time: 0:00 hour
Target version: Release 5.43

Severity: normal

Description

getting the annotations separately for each single cdm instance is quite time consuming and thus slows down the page creation of
the dataportal.

The dataportal performance could be improved if annotations would always be returned together with the cdm instances.

for Sequences this idea has been realized as a preliminary solution: r17340. See also #3347 (services and REST service controller
for molecular classes implemented)

Related issues:

Related to EDIT - feature request #9897: adapt dataportal methods for transpa... New
Related to EDIT - feature request #9896: Add annotations of the complete deri... Closed
Related to EDIT - feature request #10322: Use DTOs for portal taxon page (cont.) In Progress
Related to EDIT - bug #10472: Improve simple search performance in dataportal In Progress
History

#1 - 03/13/2013 01:41 PM - Andreas Kohlbecker

- Keywords changed from discuss to discuss performance

#2 - 03/25/2013 06:22 PM - Andreas Miiller

does this also include marker and extensions? We will have extensions for sequences in the next Alga Terra Version.

#3 - 05/07/2013 01:06 AM - Andreas Miiller
- Priority changed from Priority08 to Priority13

#4 - 04/09/2014 09:42 AM - Andreas Kohlbecker

the DescriptionPortalListController always returns the annotations for the requests to @ portal/descriptionElement/byTaxon@ but the
portal/description/distributionIinfoFor/ still needs to be adapted that way

#5 - 04/09/2014 11:04 AM - Andreas Kohlbecker
performance test with and without initialization of annotations:
1. no annotations, Time per request: 837.971 ms|1. with annotations, Time per request: 1044.011 [ms]
this is a difference of 206,039 ms for 27 elements so 7,63 ms per annotation
total performance improvement for the page loading of http://localhost/d7/euromed/cdm_dataportal/taxon/a8ceb077-cfad-4619-9c47-e8770df41bd7
total page web service fetch time as reported by the debug block for first request after restarting:
1. annotations loaded with description elements: 9.285s

2. annotations loaded separately: 13.747s

time to load the html page

1. annotations loaded with description elements: Time per request (n=10) : 6109.158 ms|1. annotations loaded separately: Time per request (n=10)
:2851.489 [ms]
mean
http://localhost/d7/euromed/cdm_dataportal/taxon/a8ceb077-cfad-4619-9c47-e8770df41bd7
mean

#6 - 04/09/2014 11:07 AM - Andreas Miiller

Did you load the full Annotation or only relevant attributes?

#7 - 04/09/2014 11:10 AM - Andreas Kohlbecker

loading annotations with distributions committed as r20576

#8 - 04/09/2014 11:15 AM - Andreas Kohlbecker

Replying to a.mueller:

Did you load the full Annotation or only relevant attributes?

as the annotations are loaded with the description elements they are loaded as full objects, e.g.

annotations": [

"annotatedObj": null,

"annotationType": {
"class": "AnnotationType",
"titleCache": "technical",
"updated": "2013-10-15T00:11:32.000+02:00",
"uuid": "6a5f9%ead-1bdd-4906-89%9ad-6e669f982d69",
"created": "2013-10-15T00:11:32.000+02:00",
"termType": "AnnotationType",
"uri":. """,
"protectedTitleCache": false,
"representation_L10n": "technical"

}I

"class": "Annotation",

"commentator": null,

"created": "2013-10-23T10:34:30.000+02:00",

"language": {
"class": "Language",
"titleCache": "English",

"updated": "2013-10-15T00:11:26.000+02:00",
"uuid": "e9f8cdb7-6819-44e8-95d3-e2d0690c3523",
"created": "2013-10-15T00:11:26.000+02:00",

"iso639_1": "en",
"termType": "Language",
"idInVocabulary": "eng",
"yri": "",
"protectedTitleCache": false,
"representation_L10n": "English",
"representation_L10n_abbreviatedLabel": "eng"
}I
"linkbackUri": "",
"text": "<?xml version='1.0' encoding='UTF-8'?><mapService xmlns=\"http://www.etaxonomy.eu/cdm\" type=

\"editMapService\"><area><layer>em_tiny_Jan2003</layer><field>EMAREA</field><value>Al</value></area></mapServi
ce>",

"updated": "2013-10-23T10:34:31.000+02:00",

"yuid": "7e6783a5-8cdc-4937-afb0-b90bfefedact"

] ’
we should of course consider loading the annotations separately for all description elements as DTOs, so that only the relevant data is loaded and

also to avoid creating the cdm entities in hibernate. This is ticket is still under discussion and my commit is only a first improvement which could be
implemented quickly.

#9 - 10/14/2016 04:24 PM - Andreas Kohlbecker
- Tags changed from discuss performance to performance

- Description updated

#10 - 11/23/2021 08:42 PM - Andreas Miiller

- Target version changed from cdmlib - Old Next Major Release to Unassigned CDM tickets

#11 - 12/10/2021 11:26 AM - Andreas Kohlbecker

- Description updated
https://dev.e-taxonomy.eu/redmine/projects/edit/wiki/Comment6

#12 - 12/10/2021 11:26 AM - Andreas Kohlbecker

- Private changed from Yes to No

#13 - 12/10/2021 11:39 AM - Andreas Kohlbecker

- Related to feature request #9897: adapt dataportal methods for transparent usage of Anntoation and AnnotationDTO added

#14 - 12/10/2021 11:39 AM - Andreas Kohlbecker

- Related to feature request #9896: Add annotations of the complete derivation branch to DerivedUnitDTO and FieldUnitDTO as AnnotationDTO
added

#15 - 03/23/2022 10:29 AM - Andreas Miiller
- Assignee changed from Andreas Kohlbecker to Andreas Mtiller
- Priority changed from Priority13 to Priority14

- Target version changed from Unassigned CDM tickets to Release 5.44

#16 - 02/14/2024 11:57 PM - Andreas Miiller

- Target version changed from Release 5.44 to Release 5.43

#17 - 03/13/2024 04:23 PM - Andreas Miiller
- Related to feature request #10322: Use DTOs for portal taxon page (cont.) added

#18 - 03/13/2024 04:26 PM - Andreas Miiller
- Status changed from New to In Progress

- % Done changed from 0 to 20

Implemented for new taxon page loading (#10322, #10222) and for simple search (annotations not needed there, #10472).

We need a list where else it is relevant.

#19 - 03/13/2024 04:26 PM - Andreas Miiller

- Related to bug #10472: Improve simple search performance in dataportal added
